package org.somda.protosdc_converter.converter.kotlin.entrygen

import org.somda.protosdc_converter.converter.kotlin.KotlinEntry
import org.somda.protosdc_converter.converter.kotlin.KotlinSource

/**
 * Code generator for [KotlinEntry.KotlinStringEnumeration] type.
 *
 * @param kotlinSource required to produce Kotlin particles.
 * @param entry the entry for which code is generated by this object.
 * @param level code depth on which code is generated (0 for no indentation).
 *              Indentation size is determined by `kotlinSource`
 */
internal class StringEnumerationGen(
    private val kotlinSource: KotlinSource,
    private val entry: KotlinEntry.KotlinStringEnumeration,
    private val level: Int
) : CodeGenerator {
    override fun enter(): String {
        return kotlinSource.indent(level) { kotlinSource.enumStart(entry.enumName) }
    }

    override fun exit(): String {
        return kotlinSource.indent(level, kotlinSource::blockEnd)
    }

    override fun main(): String {
        return entry.enumValues.joinToString(separator = "\n") {
            kotlinSource.indent(level) {
                kotlinSource.enumItem(it)
            }
        }
    }
}